﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Input;
using Telerik.Windows.Controls;

namespace MenuWPF
{
    public class ViewModel: ViewModelBase
    {
        private bool execute;

        public ViewModel()
        {
            this.OpenCommand = new DelegateCommand(OnOpenExecute, e => this.execute);
            this.CloseCommand = new DelegateCommand(OnCloseExecute, e => !this.execute);
            this.MenuItemsCollection = this.GetMenuItems();
            this.execute = true;
        }

        public ObservableCollection<MenuItem> MenuItemsCollection { get; set; }
        public ICommand OpenCommand { get; set; }
        public ICommand CloseCommand { get; set; }

        private ObservableCollection<MenuItem> GetMenuItems()
        {
            ObservableCollection<MenuItem> items = new ObservableCollection<MenuItem>();
            ObservableCollection<MenuItem> fileSubItems = new ObservableCollection<MenuItem>();

            MenuItem openItem = new MenuItem()
            {
                Header = "Open",
                Command = this.OpenCommand
            };
            fileSubItems.Add(openItem);
            MenuItem closeItem = new MenuItem()
            {
                Header = "Close",
                Command = this.CloseCommand
            };
            fileSubItems.Add(closeItem);
            MenuItem fileItem = new MenuItem()
            {
                SubItems = fileSubItems,
                Header = "File"
            };
            items.Add(fileItem);
            MenuItem editItem = new MenuItem()
            {
                Header = "Edit"
            };
            items.Add(editItem);
            MenuItem viewItem = new MenuItem()
            {
                Header = "View"
            };
            items.Add(viewItem);

            return items;
        }

        private void OnCloseExecute(object obj)
        {
            this.ChangeCanExecute();            
        }

        private void OnOpenExecute(object obj)
        {            
            this.ChangeCanExecute();
        }

        private void ChangeCanExecute()
        {
            this.execute = !this.execute;
            (this.OpenCommand as DelegateCommand).InvalidateCanExecute();
            (this.CloseCommand as DelegateCommand).InvalidateCanExecute();
        }
    }
}
